asterisk (8)

NAME
asterisk - All-purpose telephony server.

SYNOPSIS
asterisk
[-BcdfFghiImnpqRtTvVW] [-C file] [-e memory] [-G group] [-L loadaverage] [-M value] [-U user] [-s socket-file]
asterisk -r
[-v] [-d] [-x command]
asterisk -R
[-v] [-d] [-x command]

DESCRIPTION
asterisk is a full-featured telephony server which provides Private Branch eXchange (PBX), Interactive Voice Response (IVR), Automated Call Distribution (ACD), Voice over IP (VoIP) gatewaying, Conferencing, and a plethora of other telephony applications to a broad range of telephony devices including packet voice (SIP, IAX2, MGCP, Skinny, H.323, Unistim) devices (both endpoints and proxies), as well as traditional TDM hardware including T1, E1, ISDN PRI, GR-303, RBS, Loopstart, Groundstart, ISDN BRI and many more.

At start, Asterisk reads the /etc/asterisk/asterisk.conf main configuration file and locates the rest of the configuration files from the configuration in that file. The -C option specifies an alternate main configuration file. Virtually all aspects of the operation of asterisk's configuration files can be found in the sample configuration files. The format for those files is generally beyond the scope of this man page.

When running with -c, -r or -R options, Asterisk supplies a powerful command line, including command completion, which may be used to monitors its status, perform a variety of administrative actions and even explore the applications that are currently loaded into the system.

Asterisk is a trademark of Digium, Inc.

OPTIONS
Running Asterisk starts the asterisk daemon (optionally running it in the foreground). However running it with \FC-r\F[] or \FC-R\F[] connects to an existing Asterisk instance through a remote console.

-B  Force the background of the terminal to be black, in order for terminal colors to show up properly. Equivalent to \FCforceblackbackground = yes\F[] in \FCasterisk.conf\F[]. See also \FC-n\F[] and \FC-W\F[].

-C file
    Use \FCfile\F[] as master configuration file instead of the default, /etc/asterisk/asterisk.conf

-c  Provide a control console on the calling terminal. The console is similar to the remote console provided by \FC-r\F[]. Specifying this option implies -f and will cause asterisk to no longer fork or detach from the controlling terminal. Equivalent to \FCconsole = yes\F[] in \FCasterisk.conf\F[].

-d  Enable extra debugging statements. This parameter may be used several times, and each increases the debug level. Equivalent to \FCdebug = \F[]num in \FCasterisk.conf\F[] to explicitly set the initian debug level to num. When given at startup, this option also implies \FC-f\F[] (no forking). However when connecting to an existing Asterisk instance (\FC-r\F[] or \FC-R\F[]), it may only increase the debug level.

-e memory
    Limit the generation of new channels when the amount of free memory has decreased to under memory megabytes. Equivalent to \FCminmemfree = \F[]memory in \FCasterisk.conf\F[].

-f  Do not fork or detach from controlling terminal. Overrides any preceding specification of -F on the command line. Equivalent to \FCnofork = yes\F[] in \FCasterisk.conf\F[]. See also \FC-c\F[].

-F  Always fork and detach from controlling terminal. Overrides any preceding specification of -f on the command line. May also be used to prevent \FC-d\F[] and \FC-v\F[] to imply no forking. Equivalent to \FCalwaysfork = yes\F[] in \FCasterisk.conf\F[].

-g  Remove resource limit on core size, thus forcing Asterisk to dump core in the unlikely event of a segmentation fault or abort signal. NOTE: in some cases this may be incompatible with the -U or -G flags.

-G group
    Run as group group instead of the calling group. NOTE: this requires substantial work to be sure that Asterisk's environment has permission to write the files required for its operation, including logs, its comm socket, the asterisk database, etc.

-h  Provide brief summary of command line arguments and terminate.

-i  Prompt user to intialize any encrypted private keys for IAX2 secure authentication during startup.

-I  Enable internal timing if DAHDI timing is available. The default behaviour is that outbound packets are phase locked to inbound packets. Enabling this switch causes them to be locked to the internal DAHDI timer instead.

-L loadaverage
    Limits the maximum load average before rejecting new calls. This can be useful to prevent a system from being brought down by terminating too many simultaneous calls.

-m  Temporarily mutes output to the console and logs. To return to normal, use logger mute.

-M value
    Limits the maximum number of calls to the specified value. This can be useful to prevent a system from being brought down by terminating too many simultaneous calls.

-n  Disable ANSI colors even on terminals capable of displaying them. This option can be used only at startup (e.g. not with remote console).

-p  If supported by the operating system (and executing as root), attempt to run with realtime priority for increased performance and responsiveness within the Asterisk process, at the expense of other programs running on the same machine. Note: astcanary will run concurrently with asterisk. If astcanary stops running or is killed, asterisk will slow down to normal process priority, to avoid locking up the machine.

-q  Reduce default console output when running in conjunction with console mode (-c).

-r  Instead of running a new Asterisk process, attempt to connect to a running Asterisk process and provide a console interface for controlling it.

-R  Much like -r. Instead of running a new Asterisk process, attempt to connect to a running Asterisk process and provide a console interface for controlling it. Additionally, if connection to the Asterisk process is lost, attempt to reconnect for as long as 30 seconds.

-s socket file name
    In combination with -r, connect directly to a specified Asterisk server socket.

-t  When recording files, write them first into a temporary holding directory, then move them into the final location when done.

-T  Add timestamp to all non-command related output going to the console when running with verbose and/or logging to the console.

-U user
    Run as user user instead of the calling user. NOTE: this requires substantial work to be sure that Asterisk's environment has permission to write the files required for its operation, including logs, its comm socket, the asterisk database, etc.

-v  Increase the level of verboseness on the console. The more times -v is specified, the more verbose the output is. Specifying this option implies -f and will cause asterisk to no longer fork or detach from the controlling terminal. This option may also be used in conjunction with -r and -R. Note: This always sets the verbose level in the asterisk process, even if it is running in the background. This will affect the size of your log files.

-V  Display version information and exit immediately.

-W  Display colored terminal text as if the background were white or otherwise light in color. Normally, terminal text is displayed as if the background were black or otherwise dark in color.

-x command
    Connect to a running Asterisk process and execute a command on a command line, passing any output through to standard out and then terminating when the command execution completes. Implies -r when -R is not explicitly supplied.

-X  Enables executing of includes via #exec directive inside \FCasterisk.conf\F[].

EXAMPLES
asterisk - Begin Asterisk as a daemon

asterisk -vvvgc - Run on controlling terminal

asterisk -rx "core show channels" - Display channels on running server

BUGS
Bug reports and feature requests may be filed at https://github.com/asterisk/asterisk/issues/

SEE ALSO
https://www.asterisk.org - The Asterisk Home Page

http://www.asteriskdocs.org - The Asterisk Documentation Project

https://wiki.asterisk.org - The Asterisk Wiki

https://www.digium.com/ - Asterisk is sponsored by Digium

AUTHOR
Mark Spencer <markster@digium.com>

Countless other contributors, see CREDITS with distribution for more information.